'\"
'\" Generated from file './modules/snit/snitfaq.man' by tcllib/doctools with format 'nroff'
'\" Copyright (c) 2003, by William H. Duquette
'\"
'\" -*- tcl -*- doctools manpage
'\" The definitions below are for supplemental macros used in Tcl/Tk
'\" manual entries.
'\"
'\" .AP type name in/out ?indent?
'\"	Start paragraph describing an argument to a library procedure.
'\"	type is type of argument (int, etc.), in/out is either "in", "out",
'\"	or "in/out" to describe whether procedure reads or modifies arg,
'\"	and indent is equivalent to second arg of .IP (shouldn't ever be
'\"	needed;  use .AS below instead)
'\"
'\" .AS ?type? ?name?
'\"	Give maximum sizes of arguments for setting tab stops.  Type and
'\"	name are examples of largest possible arguments that will be passed
'\"	to .AP later.  If args are omitted, default tab stops are used.
'\"
'\" .BS
'\"	Start box enclosure.  From here until next .BE, everything will be
'\"	enclosed in one large box.
'\"
'\" .BE
'\"	End of box enclosure.
'\"
'\" .CS
'\"	Begin code excerpt.
'\"
'\" .CE
'\"	End code excerpt.
'\"
'\" .VS ?version? ?br?
'\"	Begin vertical sidebar, for use in marking newly-changed parts
'\"	of man pages.  The first argument is ignored and used for recording
'\"	the version when the .VS was added, so that the sidebars can be
'\"	found and removed when they reach a certain age.  If another argument
'\"	is present, then a line break is forced before starting the sidebar.
'\"
'\" .VE
'\"	End of vertical sidebar.
'\"
'\" .DS
'\"	Begin an indented unfilled display.
'\"
'\" .DE
'\"	End of indented unfilled display.
'\"
'\" .SO
'\"	Start of list of standard options for a Tk widget.  The
'\"	options follow on successive lines, in four columns separated
'\"	by tabs.
'\"
'\" .SE
'\"	End of list of standard options for a Tk widget.
'\"
'\" .OP cmdName dbName dbClass
'\"	Start of description of a specific option.  cmdName gives the
'\"	option's name as specified in the class command, dbName gives
'\"	the option's name in the option database, and dbClass gives
'\"	the option's class in the option database.
'\"
'\" .UL arg1 arg2
'\"	Print arg1 underlined, then print arg2 normally.
'\"
'\" RCS: @(#) $Id: man.macros,v 1.1 2000/03/06 21:34:53 ericm Exp $
'\"
'\"	# Set up traps and other miscellaneous stuff for Tcl/Tk man pages.
.if t .wh -1.3i ^B
.nr ^l \n(.l
.ad b
'\"	# Start an argument description
.de AP
.ie !"\\$4"" .TP \\$4
.el \{\
.   ie !"\\$2"" .TP \\n()Cu
.   el          .TP 15
.\}
.ta \\n()Au \\n()Bu
.ie !"\\$3"" \{\
\&\\$1	\\fI\\$2\\fP	(\\$3)
.\".b
.\}
.el \{\
.br
.ie !"\\$2"" \{\
\&\\$1	\\fI\\$2\\fP
.\}
.el \{\
\&\\fI\\$1\\fP
.\}
.\}
..
'\"	# define tabbing values for .AP
.de AS
.nr )A 10n
.if !"\\$1"" .nr )A \\w'\\$1'u+3n
.nr )B \\n()Au+15n
.\"
.if !"\\$2"" .nr )B \\w'\\$2'u+\\n()Au+3n
.nr )C \\n()Bu+\\w'(in/out)'u+2n
..
.AS Tcl_Interp Tcl_CreateInterp in/out
'\"	# BS - start boxed text
'\"	# ^y = starting y location
'\"	# ^b = 1
.de BS
.br
.mk ^y
.nr ^b 1u
.if n .nf
.if n .ti 0
.if n \l'\\n(.lu\(ul'
.if n .fi
..
'\"	# BE - end boxed text (draw box now)
.de BE
.nf
.ti 0
.mk ^t
.ie n \l'\\n(^lu\(ul'
.el \{\
.\"	Draw four-sided box normally, but don't draw top of
.\"	box if the box started on an earlier page.
.ie !\\n(^b-1 \{\
\h'-1.5n'\L'|\\n(^yu-1v'\l'\\n(^lu+3n\(ul'\L'\\n(^tu+1v-\\n(^yu'\l'|0u-1.5n\(ul'
.\}
.el \}\
\h'-1.5n'\L'|\\n(^yu-1v'\h'\\n(^lu+3n'\L'\\n(^tu+1v-\\n(^yu'\l'|0u-1.5n\(ul'
.\}
.\}
.fi
.br
.nr ^b 0
..
'\"	# VS - start vertical sidebar
'\"	# ^Y = starting y location
'\"	# ^v = 1 (for troff;  for nroff this doesn't matter)
.de VS
.if !"\\$2"" .br
.mk ^Y
.ie n 'mc \s12\(br\s0
.el .nr ^v 1u
..
'\"	# VE - end of vertical sidebar
.de VE
.ie n 'mc
.el \{\
.ev 2
.nf
.ti 0
.mk ^t
\h'|\\n(^lu+3n'\L'|\\n(^Yu-1v\(bv'\v'\\n(^tu+1v-\\n(^Yu'\h'-|\\n(^lu+3n'
.sp -1
.fi
.ev
.\}
.nr ^v 0
..
'\"	# Special macro to handle page bottom:  finish off current
'\"	# box/sidebar if in box/sidebar mode, then invoked standard
'\"	# page bottom macro.
.de ^B
.ev 2
'ti 0
'nf
.mk ^t
.if \\n(^b \{\
.\"	Draw three-sided box if this is the box's first page,
.\"	draw two sides but no top otherwise.
.ie !\\n(^b-1 \h'-1.5n'\L'|\\n(^yu-1v'\l'\\n(^lu+3n\(ul'\L'\\n(^tu+1v-\\n(^yu'\h'|0u'\c
.el \h'-1.5n'\L'|\\n(^yu-1v'\h'\\n(^lu+3n'\L'\\n(^tu+1v-\\n(^yu'\h'|0u'\c
.\}
.if \\n(^v \{\
.nr ^x \\n(^tu+1v-\\n(^Yu
\kx\h'-\\nxu'\h'|\\n(^lu+3n'\ky\L'-\\n(^xu'\v'\\n(^xu'\h'|0u'\c
.\}
.bp
'fi
.ev
.if \\n(^b \{\
.mk ^y
.nr ^b 2
.\}
.if \\n(^v \{\
.mk ^Y
.\}
..
'\"	# DS - begin display
.de DS
.RS
.nf
.sp
..
'\"	# DE - end display
.de DE
.fi
.RE
.sp
..
'\"	# SO - start of list of standard options
.de SO
.SH "STANDARD OPTIONS"
.LP
.nf
.ta 4c 8c 12c
.ft B
..
'\"	# SE - end of list of standard options
.de SE
.fi
.ft R
.LP
See the \\fBoptions\\fR manual entry for details on the standard options.
..
'\"	# OP - start of full description for a single option
.de OP
.LP
.nf
.ta 4c
Command-Line Name:	\\fB\\$1\\fR
Database Name:	\\fB\\$2\\fR
Database Class:	\\fB\\$3\\fR
.fi
.IP
..
'\"	# CS - begin code excerpt
.de CS
.RS
.nf
.ta .25i .5i .75i 1i
..
'\"	# CE - end code excerpt
.de CE
.fi
.RE
..
.de UL
\\$1\l'|0\(ul'\\$2
..
.TH "snitfaq" n 0.92 snit "Snit"
.BS
.SH "NAME"
snitfaq \- Snit Frequently Asked Questions
.SH "SYNOPSIS"
package require \fBTcl  8.4\fR
.sp
package require \fBsnit  ?0.92?\fR
.sp
.BE
.SH "DESCRIPTION"
.PP
.SH "OVERVIEW"
\fIWhat is this document?\fR
.PP
This is an atypical FAQ list, in that few of the questions are
frequently asked.  Rather, these are the questions I think a newcomer
to Snit should be asking.  This file is not a complete reference to
Snit, however; that information is in the \fBsnit\fR man page.
.PP
\fIWhat is Snit?\fR
.PP
Snit is a framework for defining abstract data types and megawidgets
in pure Tcl.  The name stands for "Snit's Not Incr Tcl", signifying
that Snit takes a different approach to defining objects than does
Incr Tcl, the best known object framework for Tcl.
.PP
\fIWhat version of Tcl does Snit require?\fR
.PP
Snit requires version Tcl 8.4 or later.
.PP
\fIWhat are Snit's goals?\fR
.PP
In developing Snit I had the following goals:
.PP
.IP \(bu
It should be at least as efficient as the object code I'd been writing
by hand.
.IP \(bu
The fact that Snit was used in an object's implementation should be
transparent (and irrelevant) to clients of that object.
.IP \(bu
Snit should be able to encapsulate objects from other sources,
particularly Tk widgets.
.IP \(bu
Snit megawidgets should be (to the extent possible) indistinguishable
in interface from Tk widgets.
.IP \(bu
Snit should be Tclish--that is, rather than trying to emulate C++,
Smalltalk, or anything else, it should try to emulate Tcl itself.
.IP \(bu
It should have a simple, easy-to-use, easy-to-remember syntax.
.PP
\fIHow is Snit different from other OO frameworks?\fR
.PP
Snit is unique among Tcl object systems (so far as I know) in that
it's a system based not on inheritance but on delegation.  Object
systems based on inheritance only allow you to inherit from classes
defined using the same system, and that's a shame.  In Tcl, an object
is anything that acts like an object; it shouldn't matter how the
object was implemented.  I designed Snit to help me build applications
out of the materials at hand; thus, Snit is designed to be able to
incorporate and build on any object, whether it's a hand-coded object,
a Tk widget, an Incr Tcl object, a BWidget or almost anything else.
.PP
\fIWhat can I do with Snit?\fR
.PP
Using Snit, a programmer can:
.IP \(bu
Create abstract data types and Tk megawidgets.
.IP \(bu
Define instance variables, type variables, and option variables.
.IP \(bu
Define constructors, destructors, instance methods, type methods, and
several kinds of handler.
.IP \(bu
Assemble a type out of component types.  Instance methods and options
can be delegated to the component types automatically.
.SH "OBJECTS"
\fIWhat is an object?\fR
.PP
Obviously, a full description of object-oriented programming is beyond
the scope of this FAQ.  In simple terms, an object is an instance of
an abstract data type--a coherent bundle of code and data.
There are many ways to represent objects in Tcl/Tk; the best known
example are the Tk widgets.  A widget is an object; it is represented
by a Tcl command.  The object's methods are subcommands of the Tcl
command.  Snit uses the same conventions as Tk widgets do.
.PP
\fIWhat is an abstract data type?\fR
.PP
In computer science terms, an abstract data type is a complex data
structure along with a set of operations, like a stack, a queue, or a
binary tree--that is to say, in modern terms, an object.  In systems
that include include some form of inheritance the word \fIclass\fR is
usually used instead of \fIabstract data type\fR, but as Snit
doesn't do inheritance, the older term seems more appropriate.
Sometimes this is called object-based programming as opposed to
object-oriented programming.
.PP
In Snit, as in Tk, a type is a command that creates instances --
objects -- which belong to the type.  Most types define some number of
\fIoption\fR which can be set at creation time, and usually can be
changed later.
.PP
Further, an instance is also a Tcl command--a command that gives
access to the operations which are defined for that abstract data
type.  Conventionally, the operations are defined as subcommands, or
instance methods of the instance command.  For example, to insert text
into a Tk text widget, you use the text widget's \fBinsert\fR
method:
.PP
.nf
    # Create a text widget and insert some text in it.
    text .mytext -width 80 -height 24
    .mytext insert end "Howdy!"
.fi
.PP
In this example, \fBtext\fR is the type command and \fB.mytext\fR is
the instance command.
.PP
\fIWhat kinds of abstract data types does Snit provide?\fR
.PP
Snit allows you to define three kinds of abstract data types:
.PP
.IP \(bu
\fBsnit::type\fR
.IP \(bu
\fBsnit::widget\fR
.IP \(bu
\fBsnit::widgetadaptor\fR
.PP
\fIWhat is a snit::type?\fR
.PP
A \fBsnit::type\fR is a non-GUI abstract data type, e.g., a stack or a
queue.  \fBsnit::types\fR are defined using the \fBsnit::type\fR
command.  For example, if you were designing a kennel management
system for a dog breeder, you'd need a dog type.
.PP
.nf
% snit::type dog {
    # ...
}
::dog
.fi
.PP
This definition defines a new command (\fB::dog\fR, in this case)
which can be used to define dog objects.
.PP
An instance of a \fBsnit::type\fR can have \fIinstance methods\fR,
\fIinstance variables\fR, \fIoptions\fR, and \fIcomponents\fR.
The type itself can have \fItype methods\fR and \fIprocs\fR.
.PP
\fIWhat is a snit::widget?\fR
.PP
A \fBsnit::widget\fR is a Tk megawidget built using Snit; it is very
similar to a \fBsnit::type\fR.  See \fBWIDGETS\fR.
.PP
\fIWhat is a snit::widgetadaptor?\fR
.PP
A \fBsnit::widgetadaptor\fR uses Snit to wrap an existing widget type
(e.g., a Tk label), modifying its interface to a lesser or greater
extent.  It is very similar to a \fBsnit::widget\fR.
See \fBWIDGET ADAPTORS\fR.
.PP
\fIHow do I create an instance of a snit::type?\fR
.PP
You create an instance of a \fBsnit::type\fR by passing the new
instance's name to the type's create method.  In the following
example, we create a \fBdog\fR object called \fBspot\fR.
.PP
.nf
% snit::type dog {
    # ....
}
::dog
% dog create spot
::spot
.fi
.PP
The \fBcreate\fR method name can be omitted so long as the instance
name doesn't conflict with any defined \fItype methods\fR.  So the
following example is identical to the previous example:
.PP
.nf
% snit::type dog {
    # ....
}
::dog
% dog spot
::spot
.fi
.PP
This document generally uses the shorter form.
.PP
If the \fBdog\fR type defines \fIoptions\fR, these can usually be given defaults
at creation time:
.PP
.nf
% snit::type dog {
    option -breed mongrel
    option -color brown

    method bark {} { return "$self barks." }
}
::dog
% dog create spot -breed dalmation -color spotted
::spot
% spot cget -breed
dalmation
% spot cget -color
spotted
.fi
.PP
Either way, the instance name now names a new Tcl command which is
used to manipulate the object.  For example, the following code makes
the dog bark:
.PP
.nf
% spot bark
::spot barks.
.fi
.PP
\fIHow do I refer to an object indirectly?\fR
.PP
Some programmers prefer to save the object name in a variable, and
reference it that way.  For example,
.PP
.nf
% snit::type dog {
    option -breed mongrel
    option -color brown

    method bark {} { return "$self barks." }
}
::dog
% set d [dog spot -breed dalmation -color spotted]
::spot
% $d cget -breed
dalmation
% $d bark
::spot barks.
.fi
.PP
\fIHow can I generate the object name automatically?\fR
.PP
If you'd like Snit to generate an object name for you,
use the \fB%AUTO%\fR keyword as the requested name:
.PP
.nf
    % snit::type dog {
	method bark {} { return "$self barks." }
    }
    ::dog
    % set d [dog %AUTO%]
    ::dog2
    % $d bark
    ::dog2 barks.
.fi
.PP
The "%AUTO%" keyword can be embedded in a longer string:
.PP
.nf
    % set d [dog dog%AUTO%]
    ::dogdog4
    % $d bark
    ::dogdog4 barks.
    %
.fi
.PP
\fICan types be renamed?\fR
.PP
Tcl's \fBrename\fR command renames other commands.  It's a common
technique in Tcl to modify an existing command by renaming it and
defining a new command with the original name; the new command usually
calls the renamed command.
.PP
\fBsnit::type\fR's, however, should never be renamed; to do so breaks
the connection between the type and its objects.
.PP
\fICan objects be renamed?\fR
.PP
Tcl's \fBrename\fR command renames other commands.  It's a common
technique in Tcl to modify an existing command by renaming it and
defining a new command with the original name; the new command usually
calls the renamed command.
.PP
All Snit objects (including \fIwidgets\fR and \fIwidgetadaptors\fR)
can be renamed, though this flexibility has some consequences:
.PP
.IP \(bu
In an instance method, \fBself\fR will always contain the object's
current name, so instance methods can always call other instance
methods using \fBself\fR.
.IP \(bu
If the object is renamed, however, then $self's value will change.
Therefore, don't use $self for anything that will break if $self
changes. For example, don't pass a callback command to another object
like this:
.sp
.nf
    [list $self methodname args...]
.fi
.sp
You'll get an error if this command is called after your object is
renamed.
.IP \(bu
Instead, the object should pass the callback command like this:
.sp
.nf
[mymethod methodname args...]
.fi
.sp
The \fBmymethod\fR command returns code that will call the desired
method safely; the caller of the callback can safely add additional
arguments to the end of the command as usual.
.sp
For example, one could use this code to call a method when a Tk button
is pushed:
.sp
.nf
    .btn configure -command [list $self buttonpress]
.fi
.sp
This will break if your instance is renamed.  Here's the safe way to
do it:
.sp
.nf
    .btn configure -command [mymethod buttonpress]
.fi
.IP \(bu
Every object has a private namespace; the name of this namespace is
available in method bodies, etc., as \fBselfns\fR.  This value is
constant for the life the object.
Use \fBselfns\fR instead of \fBself\fR if you need a unique token to
identify the object.
.IP \(bu
When a \fBsnit::widget\fR's instance command is renamed, its Tk window
name remains the same -- and is still extremely
important.
Consequently, the Tk window name is available in \fBsnit::widget\fR
method bodies, etc., as \fBwin\fR.  This value is constant for the
life of the object.  When creating child windows, it's best to use
\fB$win.child\fR rather than \fB$self.child\fR as the name of the
child window.
.IP \(bu
The names \fBselfns\fR and \fBwin\fR may not be used as explicit
argument names for typemethods, methods, constructors, or onconfigure
handlers.
.IP \(bu
procs defined in a Snit type or widget definition used to be able to
reference instance variables if \fBself\fR was passed to them
explicitly as the argument \fBself\fR; this is no longer the case.
.PP
\fIHow do I destroy a Snit object?\fR
.PP
Every instance of a \fBsnit::type\fR has a \fBdestroy\fR method:
.PP
.nf
    % snit::type dog {
	method bark {} { return "$self barks." }
    }
    ::dog
    % dog spot
    ::spot
    % spot bark
    ::spot barks.
    % spot destroy
    % info commands ::spot
.fi
.PP
Snit megawidgets (i.e., instances of \fBsnit::widget\fR and
\fBsnit::widgetadaptor\fR) are destroyed like any other widget: by
using the Tk \fBdestroy\fR command on the widget or on one of its
ancestors in the window hierarchy.
.PP
In addition, any Snit object of any type can be destroyed by renaming
it to the empty string using the Tcl \fBrename\fR command.
.SH "INSTANCE METHODS"
\fIWhat is an instance method?\fR
.PP
An instance method is a procedure associated with a specific object.
It is given free access to all of the object's type variables,
instance variables, and so forth.
.PP
\fIHow do I define an instance method?\fR
.PP
Instance methods are defined in the type definition using
the \fBmethod\fR statement.  Consider the following code that might be
used to add dogs to a computer simulation:
.PP
.nf
% snit::type dog {
    method bark {} {
        return "$self barks."
    }

    method chase {thing} {
        return "$self chases $thing."
    }
}
::dog
.fi
.PP
A dog can bark, and it can chase things.
.PP
The \fBmethod\fR statement looks just like a normal Tcl \fBproc\fR,
except that it appears in a \fBsnit::type\fR definition.  Notice that
every instance method gets an implicit argument called \fBself\fR;
this argument contains the object's name.
.PP
\fIHow does a client call an instance method?\fR
.PP
The method name becomes a subcommand of the object.  For example,
let's put a simulated dog through its paces:
.PP
.nf
% dog spot
::spot
% spot bark
::spot barks.
% spot chase cat
::spot chases cat.
.fi
.PP
\fIHow does an instance method call another instance method?\fR
.PP
If method A needs to call method B on the same object, it does so just
as a client does: it calls method B as a subcommand of the object
itself, using the object name stored in \fBself\fR.
.PP
Suppose, for example, that our dogs never chase anything without
barking at them:
.PP
.nf
% snit::type dog {
    method bark {} {
        return "$self barks."
    }

    method chase {thing} {
        return "$self chases $thing.  [$self bark]"
    }
}
::dog
% dog spot
::spot
% spot bark
::spot barks.
% spot chase cat
::spot chases cat.  ::spot barks.
.fi
.PP
\fIAre there any limitations on instance method names?\fR
.PP
Not really, so long as you avoid the standard instance method names:
\fBconfigure\fR, \fBconfigurelist\fR, \fBcget\fR,
\fBdestroy\fR, and \fBinfo\fR.
.PP
\fIHow do I make an instance method private?\fR
.PP
It's often useful to define private methods, that is, instance methods
intended to be called only by other methods of the same object.
.PP
Snit doesn't implement any access control on instance methods, so all
methods are \fIde facto\fR public.  Conventionally, though, the
names of public methods begin with a lower case letter, and the names
of private methods begin with an upper case letter.
.PP
For example, suppose our simulated dogs only bark in response to other
stimuli; they never bark just for fun.  So the \fBbark\fR method
could be private:
.PP
.nf
% snit::type dog {
    # Private by convention: begins with uppercase letter.
    method Bark {} {
        return "$self barks."
    }

    method chase {thing} {
        return "$self chases $thing. [$self Bark]"
    }
}
::dog
% dog fido
::fido
% fido chase cat
::fido chases cat. ::fido barks.
.fi
.PP
\fIAre there any limitations on instance method arguments?\fR
.PP
Method argument lists are defined just like normal Tcl proc argument
lists; they can include default values, and the \fBargs\fR argument.
However, every method is called with a number of implicit arguments
provided by Snit in addition to those explicitly defined.  The names
of these implicit arguments may not used to name explicit arguments.
.PP
\fIWhat implicit arguments are passed to each instance method?\fR
.PP
The arguments implicitly passed to every method are \fBtype\fR,
\fBselfns\fR, \fBwin\fR, and \fBself\fR.
.PP
\fIWhat is $type?\fR
.PP
The implicit argument \fBtype\fR contains the fully qualified name of
the object's type:
.PP
.nf
% snit::type thing {
    method mytype {} {
        return $type
    }
}
::thing
% thing something
::something
% something mytype
::thing
.fi
.PP
\fIWhat is $self?\fR
.PP
The implicit argument \fBself\fR contains the object's fully
qualified name.
.PP
If the object's command is renamed, then \fBself\fR will change to
match in subsequent calls.  Thus, your code should not assume that
\fBself\fR is constant unless you know for sure that the object
will never be renamed.
.PP
.nf
% snit::type thing {
    method myself {} {
        return $self
    }
}
::thing
% thing mutt
::mutt
% mutt myself
::mutt
% rename mutt jeff
% jeff myself
::jeff
.fi
.PP
\fIWhat is $selfns?\fR
.PP
Each Snit object has a private namespace in which to store its
\fIinstance variables\fR and \fIoptions\fR.  The implicit argument
\fBselfns\fR is the name of this namespace; it never changes, and
is constant for the life of the object, even if the object's name
changes:
.PP
.nf
% snit::type thing {
    method myNameSpace {} {
        return $selfns
    }
}
::thing
% thing jeff
::jeff
% jeff myNameSpace
::thing::Snit_inst3
% rename jeff mutt
% mutt myNameSpace
::thing::Snit_inst3
.fi
.PP
The above example reveals how Snit names an instance's private
namespace; however, you should not write code that depends on the
specific naming convention, as it might change in future releases.
.PP
\fIWhat is $win?\fR
.PP
The implicit argument \fBwin\fR is defined for all Snit methods,
including those of \fIwidgets\fR and \fIwidgetadaptors\fR, though it
makes sense mostly for the latter two kinds.  \fBwin\fR is simply
the original name of the object, whether it's been renamed or not.
For widgets and widgetadaptors, it is also therefore the name of a Tk
window.
When a \fBsnit::widgetadaptor\fR is used to modify the interface of a
widget or megawidget, it must rename the widget's original command and
replace it with its own.
Thus, using \fBwin\fR whenever the Tk window name is called for
means that a \fBsnit::widget\fR or \fBsnit::widgetadaptor\fR can be
adapted by a \fBsnit::widgetadaptor\fR.  See \fBWIDGETS\fR for
more information.
.PP
\fIHow do I pass an instance method as a callback?\fR
.PP
It depends on the context.
Suppose in my application I have a \fBdog\fR object named \fBfido\fR,
and I want \fBfido\fR to bark when a Tk button is pressed.  In this
case, I pass the instance method in the normal way, as a subcommand of
\fBfido\fR:
.PP
.nf
    button .bark -text "Bark!" -command [list fido bark]
.fi
.PP
In typical Tcl style, we use a callback to hook two independent
components together.  But what if the \fBdog\fR object itself, passing
one of its own instance methods to another object (one of its
components, say)?  The obvious thing to do is this:
.PP
.nf
% snit::widget dog {
    constructor {args} {
        #...
        button $win.barkbtn -text "Bark!"  -command [list $self bark]
        #...
    }
}
::dog
.fi
.PP
(Note that in this example, our \fBdog\fR
becomes a \fBsnit::widget\fR, because it has GUI behavior.  See
\fBWIDGETS\fR for more.)  Thus, if we create a \fBdog\fR called
\fB.spot\fR, it will create a Tk button called \fB.barkbtn\fR and pass
it \fB$self bark\fR as the command.
.PP
Now, this will work--provided that \fB.spot\fR is never renamed.  But
why should \fB.spot\fR be renamed?  Surely renaming widgets is
abnormal?  And so it is--unless \fB.spot\fR is the hull component of a
\fBsnit::widgetadaptor\fR.  If it is, then it will be renamed, and
\fB.spot\fR will name the \fBsnit::widgetadaptor\fR object.  When the
button is pressed, the command \fB$self bark\fR will be handled by
the \fBsnit::widgetadaptor\fR, which might or might not do the right
thing.
.PP
There's a safer way to do it, and it looks like this:
.PP
.nf
% snit::widget dog {
    constructor {args} {
        #...
        button $win.barkbtn -text "Bark!"  -command [mymethod bark]
        #...
    }
}
::dog
.fi
.PP
The command \fBmymethod\fR can be used like \fBlist\fR to build up a
callback command; the only difference is that \fBmymethod\fR returns a
form of the command that won't change if the instance's name changes.
.PP
\fIHow do I delegate instance methods to a component?\fR
.PP
See \fBDELEGATION\fR.
.SH "INSTANCE VARIABLES"
\fIWhat is an instance variable?\fR
.PP
An instance variable is a private variable associated with some
particular Snit object.  Instance variables can be scalars or arrays.
.PP
\fIHow is a scalar instance variable defined?\fR
.PP
Scalar instance variables are defined in the type definition using the
\fBvariable\fR statement.  You can simply name it, or you can
initialize it with a value:
.PP
.nf
snit::type mytype {
    # Define variable "greeting" and initialize it with "Howdy!"
    variable greeting "Howdy!"
}
.fi
.PP
\fIHow is an array instance variable defined?\fR
.PP
Array instance variables are also defined using the \fBvariable\fR
command; however, you can't initialize them using the variable
command.  Typically, they get initialized in the constructor:
.PP
.nf
snit::type mytype {
    # Define array variable "greetings"
    variable greetings

    constructor {args} {
        set greetings(formal) "Good Evening"
        set greetings(casual) "Howdy!"
    }
}
.fi
.PP
\fIAre there any limitations on instance variable names?\fR
.PP
Just a few.
.PP
First, every Snit object has a built-in instance variable called
\fBoptions\fR, which should never be redefined.
.PP
Second, all names beginning with "Snit_" or "snit_" are reserved for
use by Snit internal code.
.PP
Second, instance variable names with the namespace delimiter
(\fB::\fR) in them are likely to cause great confusion.
.PP
\fIDo I need to declare instance variables before using them?\fR
.PP
No. Once you've defined an instance variable in the type definition,
it can be used in any instance code without declaration.  This differs
from normal Tcl practice, in which all non-local variables in a proc
need to be declared.
.PP
\fIHow do I pass an instance variable's name to another object?\fR
.PP
In Tk, it's common to pass a widget a variable name; for example, Tk
label widgets have a \fB-textvariable\fR option which names the
variable which will contain the widget's text.  This allows the
program to update the label's value just by assigning a new value to
the variable.
.PP
If you naively pass the instance variable name to the label widget,
you'll be confused by the result; Tk will assume that the name names a
global variable.  Instead, you need to provide a fully-qualified
variable name.  From within an instance method or a constructor, you
can fully qualify the variable's name using the \fBvarname\fR command:
.PP
.nf
snit::widget mywidget {
    variable labeltext ""

    constructor {args} {
        # ...

        label $win.label -textvariable [varname labeltext]

        # ...
    }
}
.fi
.PP
\fIHow do I make an instance variable public?\fR
.PP
Practically speaking, you don't.  Instead, you'll implement public
variables as \fIoptions\fR.
Alternatively, you can write \fIinstance methods\fR to set and get
the variable's value.
.SH "OPTIONS"
\fIWhat is an option?\fR
.PP
A type's options are the equivalent of what other object-oriented
languages would call public member variables or properties: they are
data values which can be retrieved and (usually) set by the clients of
an object.  If a type is to be used a record type, it's possible that
options are all that's needed.
.PP
Snit's implementation of options follows the Tk model fairly exactly,
except that \fBsnit::type\fR objects can't interact with Tk's option
database; \fBsnit::widget\fR and \fBsnit::widgetadaptor\fR objects, on
the other hand, can and do.
.PP
\fIHow do I define an option?\fR
.PP
Options are defined in the type definition using the \fBoption\fR
statement.  Consider the following type, to be used in an application
that manages a list of dogs for a pet store:
.PP
.nf
% snit::type dog {
    option -breed mongrel
    option -color brown
    option -akc 0
    option -shots 0
}
::dog
.fi
.PP
According to this, a dog has four notable properties, or options: a
breed, a color, a flag that says whether it's pedigreed with the
American Kennel Club, and another flag that says whether it has had
its shots.  The default dog, evidently, is a brown mutt.
.PP
If no default value is specified, the option's value defaults to the
empty string.
.PP
The Snit man page refers to these as "locally defined" options.
.PP
\fIHow can a client set options at object creation?\fR
.PP
The normal convention is that the client may pass any number of
options and their values after the object's name at object creation.
For example, the ::dog command defined in the previous answer can now
be used to define individual dogs.  Any or all of the options may be
set at creation time.
.PP
.nf
  % dog spot -breed beagle -color "mottled" -akc 1 -shots 1
  ::spot
  % dog fido -shots 1
  ::fido
.fi
.PP
So ::spot is a pedigreed beagle; ::fido is a typical mutt, but his
owners evidently take care of him, because he's had his shots.
.PP
\fINote:\fR If the type defines a constructor, it can specify a
different object-creation syntax.  See \fBCONSTRUCTORS\fR for more
information.
.PP
\fIHow can a client retrieve an option's value?\fR
.PP
Retrieve option values using the \fBcget\fR method:
.PP
.nf
% spot cget -color
mottled
% fido cget -breed
mongrel
.fi
.PP
\fIHow can a client set options after object creation?\fR
.PP
Any number of options may be set at one time using the
\fBconfigure\fR instance method.  Suppose that closer inspection
shows that ::fido is a rare Arctic Boar Hound of a lovely dun color:
.PP
.nf
  % fido configure -color dun -breed "Arctic Boar Hound"
  % fido cget -color
  dun
  % fido cget -breed
  Arctic Boar Hound
.fi
.PP
Alternatively, the \fBconfigurelist\fR method takes a list of
options and values; this is some times more convenient:
.PP
.nf
% set features [list -color dun -breed "Arctic Boar Hound"]
-color dun -breed {Arctic Boar Hound}
% fido configurelist $features
% fido cget -color
dun
% fido cget -breed
Arctic Boar Hound
.fi
.PP
\fIHow should an instance method access an option value?\fR
.PP
There are two ways an instance method can set and retrieve an option's
value.  One is to use the \fBconfigure\fR and \fBcget\fR
methods, as shown below:
.PP
.nf
% snit::type dog {
    option -weight 10

    method gainWeight {} {
        set wt [$self cget -weight]
        incr wt
        $self configure -weight $wt
    }
}
::dog
% dog fido
::fido
% fido cget -weight
10
% fido gainWeight
% fido cget -weight
11
.fi
.PP
Alternatively, Snit provides a built-in array instance variable called
\fBoptions\fR.  The indices are the option names; the values are the
option values.  The method given above can thus be rewritten as
follows:
.PP
.nf
    method gainWeight {
        incr options(-weight)
    }
.fi
.PP
As you can see, using the \fBoptions\fR variable involves considerably
less typing.  If you define \fBonconfigure\fR or \fBoncget\fR
handlers, as described in the following answers, you might wish to use
the \fBconfigure\fR and \fBcget\fR methods anyway, just so that
any special processing you've implemented is sure to get done.
.PP
\fIHow can I catch changes to an option's value?\fR
.PP
Use an \fBonconfigure\fR handler.
.PP
\fIWhat is an onconfigure handler?\fR
.PP
An \fBonconfigure\fR handler is a special kind of instance method
that's called whenever the related option is given a new value via the
\fBconfigure\fR or \fBconfigurelist\fR instance methods. The
handler can validate the new value, pass it to some other object, and
anything else you'd like it to do.
.PP
An \fBonconfigure\fR handler is defined by an \fBonconfigure\fR
statement in the type definition.
Here's what the default configuration behavior would look like if
written as an \fBonconfigure\fR handler:
.PP
.nf
snit::type dog {
    option -color brown

    onconfigure -color {value} {
        set options(-color) $value
    }
}
.fi
.PP
The name of the handler is just the option name.  The argument list
must have exactly one argument; it can be called almost anything, but
conventionally it is called \fBvalue\fR.  Within the handler, the
argument is set to the new value; also, all instance variables are
available, just as in an instance method.
.PP
Note that if your handler doesn't put the value in the \fBoptions\fR
array, it doesn't get updated.
.PP
\fIHow can I catch accesses to an option's value?\fR
.PP
Use an \fBoncget\fR handler.
.PP
\fIWhat is an oncget handler?\fR
.PP
An \fBoncget\fR handler is a special kind of instance method that's
called whenever the related option's value is queried via the
\fBcget\fR instance method.  The handler can compute the value,
retrieve it from a database, or anything else you'd like it to do.
.PP
An \fBoncget\fR handler is defined by an \fBoncget\fR statement in the
type definition.  Here's what the default behavior would look like if
written as an \fBoncget\fR handler:
.PP
.nf
snit::type dog {
    option -color brown

    oncget -color {
        return $options(-color)
    }
}
.fi
.PP
The handler takes no arguments, and so has no argument list; however,
all instance variables are available, just as they are in normal
instance methods.
.SH "TYPE VARIABLES"
\fIWhat is a type variable?\fR
.PP
A type variable is a private variable associated with a Snit type
rather than with a particular instance of the type.  In C++ and Java,
the equivalent of type variables are called static member variables.
Type variables can be scalars or arrays.
.PP
\fIHow is a scalar type variable defined?\fR
.PP
Scalar type variables are defined in the type definition using the
\fBtypevariable\fR statement.  You can simply name it, or you can
initialize it with a value:
.PP
.nf
snit::type mytype {
    # Define variable "greeting" and initialize it with "Howdy!"
    typevariable greeting "Howdy!"
}
.fi
.PP
Every object of type \fBmytype\fR now has access to a single variable
called \fBgreeting\fR.
.PP
\fIHow is an array type variable defined?\fR
.PP
Array-valued type variables are also defined using the
\fBtypevariable\fR command; however, you can't initialize them that
way, just as you can't initialize array variables using Tcl's standard
\fBvariable\fR command.  \fIType constructors\fR are the usual way
to initialize array-valued type variables.
.PP
\fIAre there any limitations on type variable names?\fR
.PP
Type variable names have the same restrictions as instance variable
names.
.PP
\fIDo I need to declare type variables before using them?\fR
.PP
No. Once you've defined a type variable in the type definition, it can
be used in \fIinstance methods\fR or \fItype methods\fR without
declaration.  This differs from normal Tcl practice, in which all
non-local variables in a proc need to be declared.
.PP
\fIHow do I pass a type variable's name to another object?\fR
.PP
In Tk, it's common to pass a widget a variable name; for example, Tk
label widgets have a \fB-textvariable\fR option which names the
variable which will contain the widget's text.  This allows the
program to update the label's value just by assigning a new value to
the variable.
.PP
If you naively pass a type variable name to the label widget, you'll
be confused by the result; Tk will assume that the name names a global
variable.  Instead, you need to provide a fully-qualified variable
name.  From within an instance method or a constructor, you can fully
qualify the type variable's name using the \fBtypevarname\fR command:
.PP
.nf
snit::widget mywidget {
    typevariable labeltext ""

    constructor {args} {
        # ...

        label $win.label -textvariable [typevarname labeltext]

        # ...
    }
}
.fi
.PP
\fIHow do I make a type variable public?\fR
.PP
There are two ways to do this.  The preferred way is to write a pair
of \fItype methods\fR to set and query the variable's value.
.PP
Alternatively, you can publicize the variable's name in your
documentation and clients can access it directly.  For example,
.PP
.nf
snit::type mytype {
    typevariable myvariable
}

set ::mytype::myvariable "New Value"
.fi
.PP
As shown, type variables are stored in the type's namespace, which has
the same name as the type itself.
.SH "TYPE METHODS"
\fIWhat is a type method?\fR
.PP
A type method is a procedure associated with the type itself rather
than with any specific instance of the type.
.PP
\fIHow do I define a type method?\fR
.PP
Type methods are defined in the type definition using the
\fBtypemethod\fR statement:
.PP
.nf
    snit::type dog {
	# List of pedigreed dogs
	typevariable pedigreed

	typemethod pedigreedDogs {} {
	    return $pedigreed
	}

	# ...
    }
.fi
.PP
Suppose the \fBdog\fR type maintains a list of the names of the dogs
that have pedigrees.  The \fBpedigreedDogs\fR type method returns this
list.
.PP
The \fBtypemethod\fR statement looks just like a normal Tcl
\fBproc\fR, except that it appears in a \fBsnit::type\fR definition.
It defines the method name, the argument list, and the body of the
method.
.PP
\fIHow does a client call a type method?\fR
.PP
The method name becomes a subcommand of the type's command.  For
example,
.PP
.nf
snit::type dog {
    option -pedigreed 0

    # List of pedigreed dogs
    typevariable pedigreed

    typemethod pedigreedDogs {} {
        return $pedigreed
    }

    # ...
}

dog spot -pedigreed 1
dog fido

foreach dog ::pedigreedDogs { ... }
.fi
.PP
\fIAre there any limitations on type method names?\fR
.PP
Not really, so long as you avoid the standard type method names:
.PP
\fBcreate\fR and \fBinfo\fR.
.PP
\fIHow do I make a type method private?\fR
.PP
It's sometimes useful to define private type methods, that is, type
methods intended to be called only by other type or instance methods
of the same object.
.PP
Snit doesn't implement any access control on type methods; by
convention, the names of public methods begin with a lower case
letter, and the names of private methods begin with an upper case
letter.
.PP
Alternatively, a Snit \fBproc\fR can be used as a private type method; see
\fBPROCS\fR.
.PP
\fIAre there any limitations on type method arguments?\fR
.PP
Method argument lists are defined just like normal Tcl proc argument
lists; they can include default values, and the \fBargs\fR argument.
However, every type method is called with an implicit argument called
\fBtype\fR that contains the name of the type command.  In addition,
type methods should by convention avoid using the names of the
arguments implicitly defined for \fIinstance methods\fR.
.PP
\fIHow does an instance or type method call a type method?\fR
.PP
If an instance or type method needs to call a type method, it should
use \fBtype\fR to do so:
.PP
.nf
snit::type dog {

    typemethod pedigreedDogs {} { ... }

    typemethod printPedigrees {} {
        foreach obj [$type pedigreedDogs] { ... }
    }
}
.fi
.PP
\fIHow do I pass a type method as a callback?\fR
.PP
It's common in Tcl to pass a snippet of code to another object, for it
to call later.  Because types cannot be renamed, the thing to do is
just use the type name, or, if the callback is registered from within
a type method, \fBtype\fR.  For example, suppose we want to print a
list of pedigreed dogs when a Tk button is pushed:
.PP
.nf
  button .btn -text "Pedigrees" -command [list dog printPedigrees]
  pack .btn
.fi
.SH "PROCS"
\fIWhat is a proc?\fR
.PP
A Snit \fBproc\fR is really just a Tcl proc defined within the type's
namespace.  You can use procs for private code that isn't related to
any particular instance.  For example, I often find myself writing a
proc to pop the first item off of a list stored in a variable.
.PP
\fIHow do I define a proc?\fR
.PP
Procs are defined by including a \fBproc\fR statement in the type
definition:
.PP
.nf
snit::type mytype {
    # Pops and returns the first item from the list stored in the
    # listvar, updating the listvar
   proc pop {listvar} { ... }

   # ...
}
.fi
.PP
\fIAre there any limitations on proc names?\fR
.PP
Any name can be used, so long as it does not begin with \fBSnit_\fR;
names beginning with \fBSnit_\fR are reserved for Snit's own use.
However, the wise programmer will avoid proc names like \fBset\fR,
\fBlist\fR, \fBif\fR, and so forth that would shadow standard Tcl
command names.
.PP
By convention, proc names, being private, begin with a capital letter.
.PP
\fIHow does a method call a proc?\fR
.PP
Just like it calls any Tcl command.  For example,
.PP
.nf
snit::type mytype {
    # Pops and returns the first item from the list stored in the
    # listvar, updating the listvar
    proc Pop {listvar} { ... }

    variable requestQueue {}

    # Get one request from the queue and process it.
    method processRequest {} {
        set req [Pop requestQueue]
    }
}
.fi
.PP
\fIHow can I pass a proc to another object as a callback?\fR
.PP
I tend to use type or instance methods for this purpose and ignore
procs altogether.  But if you really need to, the \fBcodename\fR
command returns the proc's fully qualified name.
.SH "TYPE CONSTRUCTORS"
\fIWhat is a type constructor?\fR
.PP
A type constructor is a body of code that initializes the type as a
whole, rather like a C++ static initializer.  The body of a type
constructor is executed once when the type is defined, and never
again.
.PP
A type can have at most one type constructor.
.PP
\fIHow do I define a type constructor?\fR
.PP
A type constructor is defined by using the \fBtypeconstructor\fR
statement in the type definition.  For example, suppose the type uses
an array-valued type variable as a look up table:
.PP
.nf
    % snit::type mytype {
	typevariable lookupTable

	typeconstructor {
	    array set lookupTable {key value...}
	}
    }
    ::mytype
    %
.fi
.PP
.SH "CONSTRUCTORS"
\fIWhat is a constructor?\fR
.PP
In object-oriented programming, an object's constructor is responsible
for initializing the object completely at creation time. The constructor
receives the list of options passed to the \fBsnit::type\fR command's
create method and can then do whatever it likes.  That might include
computing instance variable values, reading data from files, creating
other objects, updating type variables, and so forth.
.PP
The constructor doesn't return anything.
.PP
\fIHow do I define a constructor?\fR
.PP
A constructor is defined by using the \fBconstructor\fR statement in
the type definition.  Suppose that it's desired to keep a list of all
pedigreed dogs.  The list can be maintained in a type variable and
retrieved by a type method.  Whenever a dog is created, it can add
itself to the list--provided that it's registered with the American
Kennel Club.
.PP
.nf
% snit::type dog {
    option -akc 0

    typevariable akcList {}

    constructor {args} {
        $self configurelist $args

        if {$options(-akc)} {
            lappend akcList $self
        }
    }

    typemethod akclist {} {
        return $akcList
    }
}
::dog
% dog spot -akc 1
::spot
% dog fido
::fido
% dog akclist
::spot
.fi
.PP
\fIWhat does the default constructor do?\fR
.PP
If you don't provide a constructor explicitly, you get the default
constructor, which looks like this:
.PP
.nf
% snit::type dog {
    option -breed mongrel
    option -color brown
    option -akc 0

    constructor {args} {
        $self configurelist $args
    }
}
::dog
% dog spot -breed dalmatian -color spotted -akc 1
::spot
.fi
.PP
When the constructor is called, \fBargs\fR will be set to the list of
arguments that follow the object's name.  The constructor is allowed
to interprete this list any way it chooses; the normal convention is
to assume that it's a list of option names and values, as shown in the
example above.  If you simply want to save the option values, you
should use the \fBconfigurelist\fR method, as shown.
.PP
\fICan I choose a different command line syntax for the constructor?\fR
.PP
Yes, you can.  For example, suppose we wanted to be sure that the
breed was explicitly stated for every dog at creation time, and
couldn't be changed thereafter.  One way to do that is as follows:
.PP
.nf
% snit::type dog {
    variable breed

    option -color brown
    option -akc 0

    constructor {theBreed args} {
        set breed $theBreed
        $self configurelist $args
    }

    method breed {} {
        return $breed
    }
}
::dog
% dog spot dalmatian -color spotted -akc 1
::spot
% spot breed
dalmatian
.fi
.PP
The drawback is that this creation syntax is non-standard, and may
limit the compatibility of your new type with other people's code.
For example, Snit generally assumes that \fIcomponents\fR use the
standard creation syntax.
.PP
\fIAre there any limitations on constructor arguments?\fR
.PP
Constructor argument lists are defined just like normal Tcl proc
argument list; they can include default values, and the \fBargs\fR
argument.  However, the constructor is called with a number of
implicit arguments provided by Snit in addition to those explicitly
defined.  The names of these implicit arguments may not used to name
explicit arguments.
.PP
\fIWhat implicit arguments are passed to the constructor?\fR
.PP
The constructor gets the same implicit arguments that are passed to
\fIinstance methods\fR: \fBtype\fR, \fBselfns\fR, \fBwin\fR, and
\fBself\fR.
.SH "DESTRUCTORS"
\fIWhat is a destructor?\fR
.PP
A destructor is a special kind of method that's called when an object
is destroyed.  It's responsible for doing any necessary clean-up when
the object goes away: destroying components, closing files, and so
forth.
.PP
\fIHow do I define a destructor?\fR
.PP
Destructors are defined by using the \fBdestructor\fR statement in the
type definition.  Suppose we're maintaining a list of pedigreed dogs;
then we'll want to remove dogs from it when they are destroyed.
.PP
.nf
% snit::type dog {
    option -akc 0

    typevariable akcList {}

    constructor {args} {
        $self configurelist $args

        if {$options(-akc)} {
            lappend akcList $self
        }
    }

    destructor {
        set ndx [lsearch $akcList $self]

        if {$ndx != -1} {
            set akcList [lreplace $akcList $ndx $ndx]
        }
    }

    typemethod akclist {} {
        return $akcList
    }
}
::dog
% dog spot -akc 1
::spot
% dog fido -akc 1
::fido
% dog akclist
::spot ::fido
% fido destroy
% dog akclist
::spot
.fi
.PP
\fIAre there any limitations on destructor arguments?\fR
.PP
Yes; a destructor has no explicit arguments.
.PP
\fIWhat implicit arguments are passed to the destructor?\fR
.PP
The destructor gets the same implicit arguments that are passed to
\fIinstance methods\fR: \fBtype\fR, \fBselfns\fR, \fBwin\fR, and
\fBself\fR.
.PP
\fIMust components be destroyed explicitly?\fR
.PP
Yes and no.
.PP
For a Snit megawidget (\fBsnit::widgets\fR and
\fBsnit::widgetadaptors\fR), any widget \fIcomponents\fR created by
it will be destroyed automatically when the megawidget is destroyed,
in keeping with normal Tk behavior (destroying a parent widget
destroys the whole tree).
On the other hand, all non-widget components of a Snit megawidget, and
all components of a normal \fBsnit::type\fR object, must be destroyed
explicitly in a destructor.
.SH "COMPONENTS"
\fIWhat is a component?\fR
.PP
Often an object will create and manage a number of other objects.  One
example is a Snit megawidget that composes a number of Tk widgets.
These objects are part of the main object and are thus are called
components of it.
.PP
But Snit also has a more precise meaning for \fIcomponent\fR.  The
components of a Snit object are those objects created by it to which
methods and options can be delegated.  See \fBDELEGATION\fR for
more information about delegation.
.PP
\fIHow do I create a component?\fR
.PP
First, you must decide what role a component plays within your object,
and give the role a name.  For example, suppose your \fBdog\fR object
creates a \fBtail\fR object (the better to wag with, no doubt).  The
\fBtail\fR object will have some command name, but you tell Snit about
it using its role name, as follows:
.PP
.nf
% snit::type dog {
    # Define component name as an instance variable
    variable mytail

    constructor {args} {
        # Create and save the component's command
        install mytail using tail %AUTO% -partof $self
        $self configurelist $args
    }

    method wag {} {
        $mytail wag
    }
}
::dog
.fi
.PP
As shown here, it doesn't matter what the \fBtail\fR object's real
name is; the \fBdog\fR object refers to it by its component name.
.PP
The above example shows one way to delegate the \fBwag\fR method to
the \fBmytail\fR component; see \fBDELEGATION\fR for an easier way.
.PP
\fIHow is a component named?\fR
.PP
A component has two names.  The first name represents the role the
component object plays within the Snit object.  This is the component
name proper, and is the name used to refer to the component within
Snit code.  The second name is the name of the actual component object
created by the Snit object's constructor.  This second name is always
a Tcl command name, and is referred to as the component's object name.
.PP
In the example in the previous FAQ, the component name is "mytail";
the "mytail" component's object name is chosen automatically by Snit
since %AUTO% was used when the component object was created.
.PP
\fIWhat does the install command do?\fR
.PP
The \fBinstall\fR command creates the component using the specified
command (\fBtail %AUTO% -partof $self\fR), and assigns the result to
the \fBmytail\fR variable.  For \fBsnit::type\fRs, the \fBinstall\fR
command shown above is equivalent to the following command:
.PP
.nf
    set mytail [tail %AUTO% -partof $self]
.fi
.PP
For \fBsnit::widget\fRs and \fBsnit::widgetadaptor\fRs, however, the
\fBinstall\fR> command also queries \fIthe Tk option database\fR
and initializes the component's options accordingly.  For consistency,
it's a good idea to get in the habit of using \fBinstall\fR for all
components.
.PP
\fIAre there any limitations on component names?\fR
.PP
Yes.  \fBsnit::widget\fR and \fBsnit::widgetadaptor\fR have a special
component called the \fBhull\fR component; thus, the name \fBhull\fR
should be used for no other purpose.
.PP
Component names are in fact instance variable names, and so follow the
rules for \fIinstance variables\fR.
.PP
\fIAre there any limitations on component object names?\fR
.PP
Yes.
Component objects which are Tk widgets or megawidgets must have valid
Tk window names.
Component objects which are not widgets or megawidgets must have
fully-qualified command names, i.e., names which include the full
namespace of the command.  Note that Snit always creates objects with
fully qualified names.
Second, component object names must be unique.  This is no problem for
widget components, since widget names are always unique; but consider
the following code:
.PP
.nf
    snit::type tail { ... }

    snit::type dog {
        delegate method wag to mytail

        constructor {} {
            install mytail using tail mytail
        }
    }
.fi
.PP
This code uses the component name, "mytail", as the component object
name.  This is not good, and here's why: Snit instance code executes
in the Snit type's namespace.  In this case, the mytail component is
created in the ::dog:: namespace, and will thus have the name
::dog::mytail.
.PP
Now, suppose you create two dogs.  Both will have a mytail component
called ::dog::mytail.  In other words, you've got two dogs with one
tail between them.  This is very bad.  Here are a couple of ways to
avoid it:
.PP
First, if the component type is a \fBsnit::type\fR you can
specify %AUTO% as its name, and be guaranteed to get a unique name.
This is the safest thing to do:
.PP
.nf
    install mytail using tail %AUTO%
.fi
.PP
If the component type isn't a \fBsnit::type\fR you can base the
component's object name on the type's name in some way:
.PP
.nf
     install mytail using tail $self.mytail
.fi
.PP
This isn't as safe, but should usually work out okay.
.PP
\fIMust I destroy the components I create?\fR
.PP
That depends.  When a parent widget is destroyed, all child widgets
are destroyed automatically.
Thus, if your object is a \fBsnit::widget\fR
or \fBsnit::widgetadaptor\fR you don't need to destroy any components
that are widgets.
.PP
Any non-widget components, however, and all components of a
\fBsnit::type\fR object, must be destroyed explicitly.  This is true
whether you assign them a component name or not.
.PP
.nf
% snit::type dog {
    variable mytail

    constructor {args} {
        install mytail using tail %AUTO% -partof $self
        $self configurelist $args
    }

    destructor {
        $mytail destroy
    }
}
::dog
.fi
.PP
Note that this code assumes that \fBtail\fR is also a
\fBsnit::type\fR; if not, it might need to be destroyed in some other
way.
.PP
\fICan I expose a component's object command as part of my interface?\fR
.PP
Yes, and there are two ways to do it.  The most appropriate way is
usually to use \fBDELEGATION\fR.  Delegation allows you to pass
the options and methods you specify along to particular components.
This effectively hides the components from the users of your type, and
ensures good encapsulation.
.PP
However, there are times when it's appropriate, not to mention
simpler, just to make the entire component part of your type's public
interface.
.PP
\fIHow do I expose a component's object command?\fR
.PP
Use the \fBexpose\fR statement.  For example, suppose you're creating
a combobox megawidget which owns a listbox widget, and you want to
make the listbox's entire interface public.  You can do this:
.PP
.nf
snit::widget combobox {
     expose listbox

     constructor {args} {
         install listbox using listbox $win.listbox ....

         #...
     }

     #...
}

combobox .mycombo
.mycombo listbox configure -width 30
.fi
.PP
The \fBexpose\fR statement exposes the named component by
defining a method of the same name.  The method's arguments are passed
along to the component.  Thus, the above code sets the listbox
component's "-width" to 30.
.PP
If called with no arguments, the method returns the component's object
name:
.PP
.nf
% .mycombo listbox
.mycombo.listbox
.fi
.PP
Usually you'll let the method name be the same as the component name;
however, you can rename it if necessary.  The code in the following
listing exposes the same interface as the previous example:
.PP
.nf
snit::widget combobox {
     expose mylistbox as listbox

     constructor {args} {
         install mylistbox using listbox $win.mylistbox ....

         #...
     }

     #...
}
combobox .mycombo
.mycombo listbox configure -width 30
.fi
.PP
.SH "DELEGATION"
\fIWhat is delegation?\fR
.PP
Delegation, simply put, is when you pass a task you've been given to
one of your assistants.  (You do have assistants, don't you?)  Snit
objects can do the same thing.  The following example shows one way in
which the \fBdog\fR object can delegate its \fBwag\fR method and its
\fB-taillength\fR option to its \fBtail\fR component.
.PP
.nf
% snit::type dog {
    variable mytail

    option -taillength

    onconfigure -taillength {value} {
         $mytail configure -length $value
    }

    oncget -taillength {
         $mytail cget -length
    }

    constructor {args} {
        install mytail using tail %AUTO% -partof $self
        $self configurelist $args
    }

    method wag {} {
        $mytail wag
    }
}
::dog
% snit::type tail {
    option -length 5
    option -partof
    method wag {} { return "Wag, wag, wag."}
}
::tail
% dog spot -taillength 7
::spot
% spot cget -taillength
7
% spot wag
Wag, wag, wag.
.fi
.PP
This is the hard way to do it, by it demonstrates what delegation is
all about.  See the following answers for the easy way to do it.
.PP
Note that the constructor calls the \fBconfigurelist\fR method
\fIafter\fR it creates its \fBtail\fR; otherwise,
if \fB-taillength\fR appeared in the list of \fBargs\fR we'd get an
error.
.PP
\fIHow can I delegate a method to a component object?\fR
.PP
Delegation occurs frequently enough that Snit makes it easy. Any
method can be delegated to any component by placing a single
\fBdelegate\fR statement in the type definition.
(See \fBCOMPONENTS\fR for more information about component names.)
.PP
For example, here's a much better way to delegate the \fBdog\fR
object's \fBwag\fR method:
.PP
.nf
% snit::type dog {
    delegate method wag to mytail

    constructor {args} {
        install mytail using tail %AUTO% -partof $self
        $self configurelist $args
    }
}
::dog
% snit::type tail {
    option -length 5
    option -partof
    method wag {} { return "Wag, wag, wag."}
}
::tail
% dog spot
::spot
% spot wag
Wag, wag, wag.
.fi
.PP
This code has the same affect as the code shown under the previous
question: when a \fBdog\fR's \fBwag\fR method is called, the call and
its arguments are passed along automatically to the \fBtail\fR object.
.PP
Note that when a component is mentioned in a \fBdelegate\fR statement,
the component's instance variable is defined implicitly.
.PP
Note also that you can define a method name using the \fBmethod\fR
statement, or you can define it using \fBdelegate\fR; you can't do
both.
.PP
\fICan I delegate to a method with a different name?\fR
.PP
Suppose the \fBtail\fR object has a \fBwiggle\fR method instead of a
\fBwag\fR method, and you want to delegate the \fBdog\fR's \fBwag\fR
method to the \fBtail\fR's \fBwiggle\fR method.  It's easily done:
.PP
.nf
    % snit::type dog {
	delegate method wag to mytail as wiggle

	constructor {args} {
	    install mytail using tail %AUTO% -partof $self
	    $self configurelist $args
	}
    }
    ::dog
    % snit::type tail {
	option -length 5
	option -partof
	method wiggle {} { return "Wag, wag, wag."}
    }
    ::tail
    % dog spot
    ::spot
    % spot wag
    Wag, wag, wag.
.fi
.PP
\fICan I delegate to a method with additional arguments?\fR
Suppose the \fBtail\fR object has a \fBwag\fR method
that takes as an argument the number of times the tail should be
wagged.  You want to delegate the \fBdog\fR's \fBwag\fR
method to the \fBtail\fR's \fBwag\fR method, specifying
that the tail should be wagged three times.  It's easily done:
.PP
.nf
    % snit::type dog {
	delegate method wag to mytail as {wag 3}

	constructor {args} {
	    install mytail using tail %AUTO% -partof $self
	    $self configurelist $args
	}
    }
    ::dog
    % snit::type tail {
	option -length 5
	option -partof
	method wag {count} {
	    return [string repeat "Wag " $count]
	}
    }
    ::tail
    % dog spot
    ::spot
    % spot wag
    Wag Wag Wag
    %
.fi
.PP
\fIHow can I delegate an option to a component object?\fR
.PP
The first question in this section (see \fBDELEGATION\fR) shows
one way to delegate an option to a component; but this pattern occurs
often enough that Snit makes it easy.  For example, every \fBtail\fR
object has a \fB-length\fR option; we want to allow the creator of
a \fBdog\fR object to set the tail's length.  We can do this:
.PP
.nf
% snit::type dog {
    delegate option -length to mytail

    constructor {args} {
        install mytail using tail %AUTO% -partof $self
        $self configurelist $args
    }
}
::dog
% snit::type tail {
    option -partof
    option -length 5
}
::tail
% dog spot -length 7
::spot
% spot cget -length
7
.fi
.PP
This produces nearly the same result as the \fBoncget\fR and
\fBonconfigure\fR handlers shown under the first question in this
section: whenever a \fBdog\fR object's \fB-length\fR option is set
or retrieved, the underlying \fBtail\fR object's option is set or
retrieved in turn.
.PP
Note that you can define an option name using the \fBoption\fR
statement, or you can define it using \fBdelegate\fR; you can't do
both.
.PP
\fICan I delegate to an option with a different name?\fR
.PP
In the previous answer we delegated the \fBdog\fR's \fB-length\fR
option down to its \fBtail\fR.  This is, of course, wrong.  The dog
has a length, and the tail has a length, and they are different.  What
we'd really like to do is give the \fBdog\fR a \fB-taillength\fR
option, but delegate it to the \fBtail\fR's \fB-length\fR option:
.PP
.nf
% snit::type dog {
    delegate option -taillength to mytail as -length

    constructor {args} {
        set mytail [tail %AUTO% -partof $self]
        $self configurelist $args
    }
}
::dog
% snit::type tail {
    option -partof
    option -length 5
}
::tail
% dog spot -taillength 7
::spot
% spot cget -taillength
7
.fi
.PP
\fIHow can I delegate any unrecognized method or option to a component object?\fR
.PP
It may happen that a Snit object gets most of its behavior from one of
its components.  This often happens with \fBsnit::widgetadaptors\fR,
for example, where we wish to slightly the modify the behavior of an
existing widget.  To carry on with our \fBdog\fR example, however, suppose
that we have a \fBsnit::type\fR called \fBanimal\fR that implements a
variety of animal behaviors--moving, eating, sleeping, and so forth.
We want our \fBdog\fR objects to inherit these same behaviors, while
adding dog-like behaviors of its own.
Here's how we can give a \fBdog\fR methods and options of its own
while delegating all other methods and options to its \fBanimal\fR
component:
.PP
.nf
% snit::type dog {
    delegate option * to animal
    delegate method * to animal

    option -akc 0

    constructor {args} {
        install animal using animal %AUTO% -name $self
        $self configurelist $args
    }

    method wag {} {
        return "$self wags its tail"
    }
}
::dog
.fi
.PP
That's it.  A \fBdog\fR is now an \fBanimal\fR which has a
\fB-akc\fR option and can \fBwag\fR its tail.
.PP
Note that we don't need to specify the full list of method names or
option names which \fBanimal\fR will receive.
It gets anything \fBdog\fR doesn't recognize--and if it doesn't
recognize it either, it will simply throw an error, just as it should.
.PP
\fIHow can I delegate all but certain methods or options to a component?\fR
.PP
In the previous answer, we said that every \fBdog\fR is
an \fBanimal\fR by delegating all unknown methods and options to the
\fBanimal\fR component. But what if the \fBanimal\fR type has some
methods or options that we'd like to suppress?
.PP
One solution is to explicitly delegate all the options and methods,
and forgo the convenience of \fBdelegate method *\fR and
\fBdelegate option *\fR.  But if we wish to suppress only a few
options or methods, there's an easier way:
.PP
.nf
    % snit::type dog {
	delegate option * to animal except -legs
	delegate method * to animal except {fly climb}

	# ...

	constructor {args} {
	    install animal using animal %AUTO% -name $self -legs 4
	    $self configurelist $args
	}

	# ...
    }
    ::dog
    %
.fi
.PP
Dogs have four legs, so we specify that explicitly when we create the
\fBanimal\fR component, and explicitly exclude \fB-legs\fR from the
set of delegated options.  Similarly, dogs can neither fly nor climb,
so we exclude those \fBanimal\fR methods as shown.
.SH "WIDGETS"
\fIWhat is a snit::widget?\fR
.PP
A \fBsnit::widget\fR is the Snit version of what Tcl programmers
usually call a \fImegawidget\fR: a widget-like object usually
consisting of one or more Tk widgets all contained within a Tk frame.
.PP
A \fBsnit::widget\fR is also a special kind of \fBsnit::type\fR.  Just
about everything in this FAQ list that relates to \fBsnit::types\fR
also applies to \fBsnit::widgets\fR.
.PP
\fIHow do I define a snit::widget?\fR
.PP
\fBsnit::widgets\fR are defined using the \fBsnit::widget\fR command,
just as \fBsnit::types\fR are defined by the \fBsnit::type\fR command.
.PP
The body of the definition can contain all of the same kinds of
statements, plus a couple of others which will be mentioned below.
.PP
\fIHow do snit::widgets differ from snit::types?\fR
.PP
.IP \(bu
The name of an instance of a \fBsnit::type\fR can be any valid Tcl
command name, in any namespace.
The name of an instance of a \fBsnit::widget\fR must be a valid Tk
widget name, and its parent widget must already exist.
.IP \(bu
An instance of a \fBsnit::type\fR can be destroyed by calling
its \fBdestroy\fR method.  Instances of a \fBsnit::widget\fR have no
destroy method; use the Tk \fBdestroy\fR command instead.
.IP \(bu
Every instance of a \fBsnit::widget\fR has one predefined component
called its \fBhull\fR component.
The hull is a Tk \fBframe\fR or \fBtoplevel\fR widget; any other
widgets created as part of the \fBsnit::widget\fR will usually be
contained within this frame.
.IP \(bu
\fBsnit::widget\fRs can have their options receive default values from
\fIthe Tk option database\fR.
.PP
\fIHow can I set the hull type for a snit::widget?\fR
A \fBsnit::widget\fR's hull component will usually be a Tk \fBframe\fR
widget; however, it may also be a \fBtoplevel\fR widget.  You can
explicitly choose one or the other by including the \fBhulltype\fR
command in the widget definition:
.PP
.nf
    snit::widget mytoplevel {
	hulltype toplevel

	# ...
    }
.fi
.PP
If no \fBhulltype\fR command appears, the hull will be a \fBframe\fR.
.PP
\fIHow should I name widgets which are components of a snit::widget?\fR
.PP
Every widget, whether a genuine Tk widget or a Snit megawidget, has to
have a valid Tk window name.  When a \fBsnit::widget\fR is first
created, its instance name, \fBself\fR, is a Tk window name;
however, if the \fBsnit::widget\fR is used as the hull component by a
\fBsnit::widgetadaptor\fR its instance name will be changed to
something else.  For this reason, every \fBsnit::widget\fR method,
constructor, destructor, and so forth is passed another implicit
argument, \fBwin\fR, which is the window name of the megawidget.  Any
children must be named using \fBwin\fR as the root.
.PP
Thus, suppose you're writing a toolbar widget, a frame consisting of a
number of buttons placed side-by-side.  It might look something like
this:
.PP
.nf
snit::widget toolbar {
    delegate option * to hull

    constructor {args} {
        button $win.open -text Open -command [mymethod open]
        button $win.save -text Save -command [mymethod save]

        # ....

        $self configurelist $args

    }
}
.fi
.PP
See also the question on renaming objects, toward the top of this
file.
.PP
.SH "WIDGETADAPTORS"
\fIWhat is a snit::widgetadaptor?\fR
.PP
A \fBsnit::widgetadaptor\fR is a kind of \fBsnit::widget\fR.  Whereas
a \fBsnit::widget\fR's hull is automatically created and is always a
Tk frame, a \fBsnit::widgetadaptor\fR can be based on any Tk
widget--or on any Snit megawidget, or even (with luck) on megawidgets
defined using some other package.
.PP
It's called a \fIwidget adaptor\fR because it allows you to take an
existing widget and customize its behavior.
.PP
\fIHow do I define a snit::widgetadaptor?\fR
.PP
Using the \fBsnit::widgetadaptor\fR command.  The definition for a
\fBsnit::widgetadaptor\fR looks just like that for a \fBsnit::type\fR
or \fBsnit::widget\fR, except that the constructor must create and
install the hull component.
.PP
For example, the following code creates a read-only text widget by the
simple device of turning its \fBinsert\fR and \fBdelete\fR
methods into no-ops.  Then, we define new methods, \fBins\fR and
\fBdel\fR,
which get delegated to the hull component as \fBinsert\fR and
\fBdelete\fR.  Thus, we've adapted the text widget and given it new
behavior while still leaving it fundamentally a text widget.
.PP
.nf
% ::snit::widgetadaptor rotext {

    constructor {args} {
        # Create the text widget; turn off its insert cursor
        installhull using text -insertwidth 0

        # Apply any options passed at creation time.
        $self configurelist $args
    }

    # Disable the text widget's insert and delete methods, to
    # make this readonly.
    method insert {args} {}
    method delete {args} {}

    # Enable ins and del as synonyms, so the program can insert and
    # delete.
    delegate method ins to hull as insert
    delegate method del to hull as delete

    # Pass all other methods and options to the real text widget, so
    # that the remaining behavior is as expected.
    delegate method * to hull
    delegate option * to hull
}
::rotext
.fi
.PP
The most important part is in the constructor.
Whereas \fBsnit::widget\fR creates the hull for you,
\fBsnit::widgetadaptor\fR cannot -- it doesn't know what kind of
widget you want.  So the first thing the constructor does is create
the hull component (a Tk text widget in this case), and then installs
it using the \fBinstallhull\fR command.
.PP
\fINote:\fR There is no instance command until you create one by
installing a hull component.  Any attempt to pass methods to $self
prior to calling \fBinstallhull\fR will fail.
.PP
\fICan I adapt a widget created by someone else?\fR
.PP
Yes.
.PP
At times, it can be convenient to adapt a widget created by another
party.  For example, the Bwidgets \fBPagesManager\fR widget manages a
set of \fBframe\fR widgets, only one of which is visible at a time.
The application chooses which \fBframe\fR is visible.
These \fBframe\fRs are created by the \fBPagesManager\fR itself, using
its \fBadd\fR method.
.PP
In a case like this, the Tk widget will already exist when the
\fBsnit::widgetadaptor\fR is created.  Snit provides an alternate form
of the \fBinstallhull\fR command for this purpose:
.PP
.nf
    snit::widgetadaptor pageadaptor {
	constructor {args} {
	    # The widget already exists; just install it.
	    installhull $win

	    # ...
	}
    }
.fi
.SH "THE TK OPTION DATABASE"
\fIWhat is the Tk option database?\fR
.PP
The Tk option database is a database of default option values
maintained by Tk itself; every Tk application has one.  The concept of
the option database derives from something called the X Windows
resource database; however, the option database is available in every
Tk implementation, including those which do not use the X Windows
system (e.g., Microsoft Windows).
.PP
Full details about the Tk option database are beyond the scope of this
document; both \fIPractical Programming in Tcl and Tk\fR by Welch,
Jones, and Hobbs, and \fIEffective Tcl/Tk Programming\fR by
Harrison and McClennan., have good introductions to it.
.PP
Snit is implemented so that most of the time it will simply do the
right thing with respect to the option database, provided that the
widget developer does the right thing by Snit.  The body of this
section goes into great deal about what Snit requires.  The following
is a brief statement of the requirements, for reference.
.PP
.IP \(bu
If the widget's default widget class is not what is desired, set it
explicitly using the \fBwidgetclass\fR statement in the widget
definition.
.IP \(bu
When defining or delegating options, specify the resource and class
names explicitly when necessary.
.IP \(bu
Use the \fBinstallhull using\fR command to create and install the
hull for \fBsnit::widgetadaptor\fRs.
.IP \(bu
Use the \fBinstall\fR command to create and install all
other components.
.PP
The interaction of Tk widgets with the option database is a complex
thing; the interaction of Snit with the option database is even more
so, and repays attention to detail.
.PP
\fIDo snit::types use the Tk option database?\fR
.PP
No, they don't; querying the option database requires a Tk window
name, and \fBsnit::type\fRs don't have one.
.PP
Only \fBsnit::widget\fRs and \fBsnit::widgetadaptor\fRs query the
option database.
.PP
\fIWhat is my snit::widget's widget class?\fR
.PP
Every Tk widget has a "widget class": a name that is used when adding
option settings to the database.  For Tk widgets, the widget class is
the same as the widget command name with an initial capital.  For
example, the widget class of the Tk \fBbutton\fR widget is "Button".
.PP
Similarly, the widget class of a \fBsnit::widget\fR defaults to the
unqualified type name with the first letter capitalized.  For example,
the widget class of
.PP
.nf
    snit::widget ::mylibrary::scrolledText { ... }
.fi
.PP
is "ScrolledText".
.PP
The widget class can also be set explicitly using the
\fBwidgetclass\fR statement within the \fBsnit::widget\fR definition:
.PP
.nf
    snit::widget ::mylibrary::scrolledText {
	widgetclass Text

	# ...
    }
.fi
.PP
The above definition says that a \fBscrolledText\fR megawidget has the
same widget class as an ordinary \fBtext\fR widget.  This might or
might not be a good idea, depending on how the rest of the megawidget
is defined, and how its options are delegated.
.PP
\fIWhat is my snit::widgetadaptor's widget class?\fR
.PP
The widget class of a \fBsnit::widgetadaptor\fR is just the widget
class of its hull widget; Snit has no control over this.
.PP
Note that the widget class can be changed only for \fBframe\fR and
\fBtoplevel\fR widgets, which is why these are the valid hull types
for \fBsnit::widget\fRs.
.PP
Try to use \fBsnit::widgetadaptor\fRs only to make small modifications
to another widget's behavior.  Then, it will usually not make sense to
change the widget's widget class anyway.
.PP
\fIWhat are option resource and class names?\fR
.PP
Every Tk widget option has three names: the option name, the resource
name, and the class name.
The option name begins with a hyphen and is all lowercase; it's used
when creating widgets, and with the \fBconfigure\fR and \fBcget\fR
commands.
.PP
The resource and class names are used to initialize option
default values by querying the option database.
The resource name is usually just the option
name minus the hyphen, but may contain uppercase letters at word
boundaries; the class name is usually just the resource
name with an initial capital, but not always.  For example, here are
the option, resource, and class names for several Tk \fBtext\fR
widget options:
.PP
.nf
    -background         background         Background
    -borderwidth        borderWidth        BorderWidth
    -insertborderwidth  insertBorderWidth  BorderWidth
    -padx               padX               Pad
.fi
.PP
As is easily seen, sometimes the resource and class names can be
inferred from the option name, but not always.
.PP
\fIWhat are the resource and class names for my megawidget's options?\fR
.PP
For options implicitly delegated to a component using
\fBdelegate option *\fR, the resource and class names will be
exactly those defined by the component.  The \fBconfigure\fR method
returns these names, along with the option's default and current
values:
.PP
.nf
    % snit::widget mytext {
	delegate option * to text

	constructor {args} {
	    install text using text .text
	    # ...
	}

	# ...
    }
    ::mytext
    % mytext .text
    .text
    % .text configure -padx
    -padx padX Pad 1 1
    %
.fi
.PP
For all other options (whether locally defined or explicitly
delegated), the resource and class names can be defined explicitly, or
they can be allowed to have default values.
.PP
By default, the resource name is just the option name minus the
hyphen; the the class name is just the option name with an initial
capital letter.  For example, suppose we explicitly delegate "-padx":
.PP
.nf
    % snit::widget mytext {
	option -myvalue 5

	delegate option -padx to text
	delegate option * to text

	constructor {args} {
	    install text using text .text
	    # ...
	}

	# ...
    }
    ::mytext
    % mytext .text
    .text
    % .text configure -mytext
    -mytext mytext Mytext 5 5
    % .text configure -padx
    -padx padx Padx 1 1
    %
.fi
.PP
Here the resource and class names are chosen using the default rules.
Often these rules are sufficient, but in the case of "-padx" we'd most
likely prefer that the option's resource and class names are the same
as for the built-in Tk widgets.  This is easily done:
.PP
.nf
    % snit::widget mytext {
	delegate option {-padx padX Pad} to text

	# ...
    }
    ::mytext
    % mytext .text
    .text
    % .text configure -padx
    -padx padX Pad 1 1
    %
.fi
.PP
\fIHow does Snit initialize my megawidget's locally-defined options?\fR
.PP
The option database is queried for each of the megawidget's
locally-defined options, using the option's resource and class name.
If the result isn't "", then it replaces the default value given in
widget definition.  In either case, the default can be overriden by
the caller.  For example,
.PP
.nf
    option add *Mywidget.texture pebbled

    snit::widget mywidget {
	option -texture smooth
	# ...
    }

    mywidget .mywidget -texture greasy
.fi
.PP
Here, "-texture" would normally default to "smooth", but because of
the entry added to the option database it defaults to "pebbled".
However, the caller has explicitly overridden the default, and so the
new widget will be "greasy".
.PP
\fIHow does Snit initialize delegated options?\fR
.PP
That depends on whether the options are delegated to the hull, or to
some other component.
.PP
\fIHow does Snit initialize options delegated to the hull?\fR
.PP
A \fBsnit::widget\fR's hull is a widget, and given that its class has
been set it is expected to query the option database for itself.  The
only exception concerns options that are delegated to it with a
different name.  Consider the following code:
.PP
.nf
    option add *Mywidget.borderWidth 5
    option add *Mywidget.relief sunken
    option add *Mywidget.hullbackground red
    option add *Mywidget.background green

    snit::widget mywidget {
	delegate option -borderwidth to hull
	delegate option -hullbackground to hull as -background
	delegate option * to hull
	# ...
    }

    mywidget .mywidget

    set A [.mywidget cget -relief]
    set B [.mywidget cget -hullbackground]
    set C [.mywidget cget -background]
    set D [.mywidget cget -borderwidth]
.fi
.PP
The question is, what are the values of variables A, B, C and D?
.PP
The value of A is "sunken".  The hull is a Tk frame which has been
given the widget class "Mywidget"; it will automatically query the
option database and pick up this value.  Since the -relief option is
implicitly delegated to the hull, Snit takes no action.
.PP
The value of B is "red".  The hull will automatically pick up the
value "green" for its -background option, just as it picked up the
-relief value.  However, Snit knows that -hullbackground is mapped to
the hull's -background option; hence, it queries the option database
for -hullbackground and gets "red" and updates the hull accordingly.
.PP
The value of C is also "red", because -background is implicitly
delegated to the hull; thus, retrieving it is the same as retrieving
-hullbackground.  Note that this case is unusual; the -background
option should probably have been excluded using the delegate
statement's "except" clause, or (more likely) delegated to some other
component.
.PP
The value of D is "5", but not for the reason you think.  Note that as
it is defined above, the resource name for -borderwidth defaults to
"borderwidth", whereas the option database entry is "borderWidth", in
accordance with the standard Tk naming for this option.  As with
-relief, the hull picks up its own "-borderwidth" option before Snit
does anything.  Because the option is delegated under its own name,
Snit assumes that the correct thing has happened, and doesn't worry
about it any further.  To avoid confusion, the -borderwidth option
should have been delegated like this:
.PP
.nf
    delegate option {-borderwidth borderWidth BorderWidth} to hull
.fi
.PP
For \fBsnit::widgetadaptor\fRs, the case is somewhat altered.  Widget
adaptors retain the widget class of their hull, and the hull is not
created automatically by Snit.  Instead, the \fBsnit::widgetadaptor\fR
must call \fBinstallhull\fR in its constructor.  The normal way
to do this is as follows:
.PP
.nf
    snit::widgetadaptor mywidget {
	# ...
	constructor {args} {
	    # ...
	    installhull using text -foreground white
	    #
	}
	#...
    }
.fi
.PP
In this case, the \fBinstallhull\fR command will create the hull using
a command like this:
.PP
.nf
    set hull [text $win -foreground white]
.fi
.PP
The hull is a \fBtext\fR widget, so its widget class is "Text".  Just
as with \fBsnit::widget\fR hulls, Snit assumes that it will pick up
all of its normal option values automatically, without help from Snit.
Options delegated from a different name are initialized from the
option database in the same way as described above.
.PP
In earlier versions of Snit, \fBsnit::widgetadaptor\fRs were expected
to call \fBinstallhull\fR like this:
.PP
.nf
    installhull [text $win -foreground white]
.fi
.PP
This form still works--but Snit will not query the option database as
described above.
.PP
\fIHow does Snit initialize options delegated to other components?\fR
.PP
For hull components, Snit assumes that Tk will do most of the work
automatically.  Hull components are somewhat more complicated, because
they are matched against the option database twice.
.PP
A component widget remains a widget still, and is therefore
initialized from the option database in the usual way.  A \fBtext\fR
widget remains a \fBtext\fR widget whether it is a component of a
megawidget or not, and will be created as such.
.PP
But then, the option database is queried for all options delegated to
the component, and the component is initialized accordingly--provided
that the \fBinstall\fR command is used to create it.
.PP
Before option database support was added to Snit, the usual way to
create a component was to simply create it in the constructor and
assign its command name to the component variable:
.PP
.nf
    snit::widget mywidget {
	delegate option -background to myComp

	constructor {args} {
	    set myComp [text $win.text -foreground black]
	}
    }
.fi
.PP
The drawback of this method is that Snit has no opportunity to
initialize the component properly.  Hence, the following approach is
now used:
.PP
.nf
    snit::widget mywidget {
	delegate option -background to myComp

	constructor {args} {
	    install myComp using text $win.text -foreground black
	}
    }
.fi
.PP
The \fBinstall\fR command does the following:
.PP
.IP \(bu
Builds a list of the options explicitly included in the \fBinstall\fR
command--in this case, -foreground.
.IP \(bu
Queries the option database for all options delegated explicitly to
the named component.
.IP \(bu
Creates the component using the specified command, after inserting
into it a list of options and values read from the option database.
Thus, the explicitly include options (-foreground) will override
anything read from the option database.
.IP \(bu
If the widget definition implicitly delegated options to the component
using \fBdelegate option *\fR, then Snit calls the newly created
component's \fBconfigure\fR method to receive a list of all of the
component's options.  From this Snit builds a list of options
implicitly delegated to the component which were not explicitly
included in the \fBinstall\fR command.  For all such options, Snit
queries the option database and configures the component accordingly.
You don't really need to know all of this; just use \fBinstall\fR to
install your components, and Snit will try to do the right thing.
.PP
\fIWhat happens if I install a non-widget as a component of widget?\fR
.PP
A \fBsnit::type\fR never queries the option database.
However, a \fBsnit::widget\fR can have non-widget components.  And if
options are delegated to those components, and if the \fBinstall\fR
command is used to install those components, then they will be
initialized from the option database just as widget components are.
.PP
However, when used within a megawidget, \fBinstall\fR assumes that the
created component uses a reasonably standard widget-like creation
syntax.  If it doesn't, don't use \fBinstall\fR.
.PP
.PP
\fICan I adapt widgets from other megawidget packages?\fR
.PP
Yes.
.PP
However, you need to be very careful about making sure the
\fBbindtags\fR are done properly.  There's no way for Snit to take
into account all the possible weird things other megawidget frameworks
might do wrong.
.PP
For example, some widgets in BWidgets place their own <Destroy>
binding not on a separate bind-tag, but on the widget itself. When
used as the hull of a \fBsnit::widgetadaptor\fR this causes them to be
called before Snit, removing the widget command. A previous version of
Snit was tripped by this and threw errors because it tried to operate
on and with an already deleted widget command. Snit is now able to
deal with this, despite the fact that the ultimate cause is at least
bad behaviour of Bwidget, possibly even a bug. This however does not
preclude that there might be other issues lurking.
.SH "KEYWORDS"
BWidget, C++, Incr Tcl, adaptors, class, mega widget, object, object oriented, widget, widget adaptors
.SH "COPYRIGHT"
.nf
Copyright (c) 2003, by William H. Duquette
.fi